--- old/usr/src/uts/intel/os/fpu.c	Wed Apr 12 20:33:33 2023
+++ new/usr/src/uts/intel/os/fpu.c	Wed Apr 12 20:33:33 2023
@@ -489,6 +940,13 @@
 CTASSERT(sizeof (struct xsave_state) >= AVX_XSAVE_SIZE);
 
 /*
+ * Basic architectural alignment information.
+ */
+#define	FPU_ALIGN_XMM	16
+#define	FPU_ALIGN_YMM	32
+#define	FPU_ALIGN_ZMM	64
+
+/*
  * This structure is the x86 implementation of the kernel FPU that is defined in
  * uts/common/sys/kfpu.h.
  */
@@ -550,18 +1008,6 @@
 uint32_t sse_mxcsr_mask = SSE_MXCSR_MASK_DEFAULT;
 
 /*
- * Initial kfpu state for x87 used by fpinit()
- */
-const struct fnsave_state x87_initial = {
-	FPU_CW_INIT,	/* f_fcw */
-	0,		/* __f_ign0 */
-	0,		/* f_fsw */
-	0,		/* __f_ign1 */
-	0xffff,		/* f_ftw */
-	/* rest of structure is zero */
-};
-
-/*
  * This vector is patched to xsave_ctxt() or xsaveopt_ctxt() if we discover we
  * have an XSAVE-capable chip in fpu_probe.
  */
@@ -661,7 +1107,7 @@
 
 	/*
 	 * Mark that both the parent and child need to have the FPU cleaned up
-	 * before returning to user land.
+	 * before returning to userland.
 	 */
 
 	ctxop_attach(ct, fp_ctxop_allocate(cfp));
@@ -866,6 +1312,7 @@
 	 */
 	lwp->lwp_fpu = fp->fpu_regs.kfpu_u.kfpu_generic =
 	    kmem_cache_alloc(fpsave_cachep, KM_SLEEP);
+	fp->fpu_signal = NULL;
 
 	if (fp_save_mech == FP_XSAVE) {
 		/*
@@ -888,6 +1335,11 @@
 		    fp->fpu_regs.kfpu_u.kfpu_generic);
 		lwp->lwp_fpu = fp->fpu_regs.kfpu_u.kfpu_generic = NULL;
 	}
+
+	if (fp->fpu_signal != NULL) {
+		kmem_cache_free(fpsave_cachep, fp->fpu_signal);
+		fp->fpu_signal = NULL;
+	}
 }
 
 /*
@@ -917,6 +1369,8 @@
 	bcopy(lwp->lwp_pcb.pcb_fpu.fpu_regs.kfpu_u.kfpu_generic, xp, sz);
 	/* now restore the pointer */
 	lwp->lwp_pcb.pcb_fpu.fpu_regs.kfpu_u.kfpu_generic = xp;
+	/* Ensure that we don't inherit our parent's signal state */
+	lwp->lwp_pcb.pcb_fpu.fpu_signal = NULL;
 }
 
 /*
